float Interpolate(float aX, float aXMin, float aYMin, float aXMax, float aYMax)
{
	return mix(aYMin, aYMax, (aX - aXMin) / (aXMax - aXMin));
}



void main()
{
	float tx = gl_TexCoord[0].s * 60.0 / 11.0 - 0.5;
	float ty = gl_TexCoord[0].t - 0.5;
	float c;
	if (tx < 0.0)
		c = sqrt(clamp(pow(tx * 2.0, 2.0) + pow(ty * 2.0, 2.0), 0.0, 1.0));
	else
		c = clamp(abs(ty * 2.0) * exp(tx * 0.4) + (pow(tx, 2.0) / 20.0), 0.0, 1.0);

	if (c >= 0.0 && c <= 0.3)
	{
		gl_FragColor = vec4(Interpolate(c, 0.0, 1.0, 0.3, 0.9765),
				Interpolate(c, 0.0, 0.9765, 0.3, 0.8118),
				Interpolate(c, 0.0, 0.8980, 0.3, 0.2667),
				Interpolate(c, 0.0, 1.0, 0.3, 0.9));
	}
	else if (c > 0.3 && c <= 0.7)
	{
		gl_FragColor = vec4(Interpolate(c, 0.3, 0.9765, 0.7, 0.9372),
				Interpolate(c, 0.3, 0.8118, 0.7, 0.7804),
				Interpolate(c, 0.3, 0.2667, 0.7, 0.2157),
				Interpolate(c, 0.3, 0.9, 0.7, 0.8));
	}
	else if (c > 0.7 && c <= 1.0)
	{
		gl_FragColor = vec4(Interpolate(c, 0.7, 0.9372, 1.0, 239.0 / 255.0),
				Interpolate(c, 0.7, 0.7804, 1.0, 229.0 / 255.0),
				Interpolate(c, 0.7, 0.2157, 1.0, 229.0 / 255.0),
				Interpolate(c, 0.7, 0.8, 1.0, 0.0));
	}
}