﻿module Obelisk.IObelisk;
import Obelisk.CColour, Obelisk.CTexture, Obelisk.CVector, Obelisk.EKey;

interface IObelisk
{
	void SetDirectory(string aDirectory);
	void SetCaption(string aCaption);
	void SetSize(int aXSize, int aYSize);

	void StartTimer();
	void StopTimer();

	uint CreateTimer();
	uint Duration(uint aTimer);

	bool MouseButtonDown(bool aRight);
	bool MouseButtonClicked(bool aRight);
	bool MouseButtonReleased(bool aRight);
	void GetCursorPos(out int aCursorX, out int aCursorY);

	bool IsKeyPressed(EKey aKey);
	bool IsKeyDown(EKey aKey);

	// graphics functions
	void LoadTexture(string aName, bool aTransparent);
	CTexture CreateTexture(string aName, uint[] aData, int aXSize, int aYSize);
	CTexture GetTexture(string aName);
	void LoadShader(string aName);
	void SetLinearFiltering(bool aLinearFiltering);
	void SetSpriteAlign(bool aSpriteAlign);

	void BeginFrame();
	void EndFrame();
	void SetBackgroundColour(float aR, float aG, float aB);
	void SetAlpha(float aAlpha);

	void SetSpriteViewport(int aXSize, int aYSize);
	void DrawSprite(CTexture aTexture, int aX, int aY, int aXSize = -1, int aYSize = -1,
			float aXAlign = 0, float aYAlign = 0);

	void TriColour(CVector aV0, CVector aV1, CVector aV2, CColour aColour);
	void TriColour(CVector aV0, CColour aC0, CVector aV1, CColour aC1, CVector aV2,
			CColour aC2);
	void TriTexture(CVector aV0, float aS0, float aT0, CVector aV1, float aS1, float aT1,
			CVector aV2, float aS2, float aT2, CTexture aTexture);
	void QuadShader(CVector aV0, float aS0, float aT0, CVector aV1, float aS1, float aT1,
			CVector aV2, float aS2, float aT2, CVector aV3, float aS3, float aT3,
			string aShaderName);

	void LoadFontImage(string aName);
	void SetFont(string aName);
	void DrawText(string aText, int aX, int aY);

	// audio functions
	void LoadSound(string aName);
	void Sound(string aName);
}