﻿module Windows.CThreadWrapper;
import win32.windows;
import Obelisk.IThread, Obelisk.IThreadObelisk, Windows.CApplication;

class CThreadWrapper : IThreadObelisk
{
	private CApplication mApplication;
	private IThread mThread;
	private HANDLE mThreadHandle;
	private HANDLE mStopped;
	private bool mIOStopped;

	public this(CApplication aApplication, IThread aThread)
	{
		mApplication = aApplication;
		mThread = aThread;
		mThreadHandle = NULL;
		mStopped = CreateEvent(NULL, true, false, NULL);
		assert(mStopped != NULL);
		mIOStopped = false;
	}



	public ~this()
	{
		bool CHResult;
		version (NoThreads) {} else
		{
			assert(mThreadHandle != NULL);
			CHResult = 0 != CloseHandle(mThreadHandle);
			assert(CHResult);
		}
		CHResult = 0 != CloseHandle(mStopped);
		assert(CHResult);
		delete mThread;
	}



	public void Stop()
	{
		bool SEResult = 0 != SetEvent(mStopped);
		assert(SEResult);
		mIOStopped = mApplication.CancelSynchronousIo(mThreadHandle);
		assert(mIOStopped || GetLastError() == ERROR_NOT_FOUND);
	}



	public bool IsStopped()
	{
		DWORD WFSOResult = WaitForSingleObject(mStopped, 0);
		assert(WFSOResult == WAIT_OBJECT_0 || WFSOResult == WAIT_TIMEOUT);
		if (WFSOResult == WAIT_OBJECT_0)
		{
			mIOStopped = true;
			return true;
		}
		return false;
	}
}