﻿module CRobot;
import std.random;

class CRobot
{
	private int mX;
	private int mY;
	private int mType;
	private int mHP;
	private int mFireballDamage;
	private int mFireRate;
	private int mFireballSpeed;
	private int mFireballRadius;
	private int mDamageTime = 0;
	private int mShootTime;
	private bool mSelected = false;

	public this(int aX, int aY, int aType, int aHP, int aFireballDamage, int aFireRate,
			int aFireballSpeed, int aFireballRadius)
	{
		mX = aX;
		mY = aY;
		mType = aType;
		mHP = aHP;
		mFireballDamage = aFireballDamage;
		mFireRate = aFireRate;
		mFireballSpeed = aFireballSpeed;
		mFireballRadius = aFireballRadius;
		mShootTime = uniform(mFireRate, mFireRate * 2);
	}



	public int GetX()
	{
		return mX;
	}



	public int GetY()
	{
		return mY;
	}



	public int GetType()
	{
		return mType;
	}



	public int GetFireballDamage()
	{
		return mFireballDamage;
	}



	public int GetFireballSpeed()
	{
		return mFireballSpeed;
	}



	public int GetFireballRadius()
	{
		return mFireballRadius;
	}



	public bool IsDamaged()
	{
		return mDamageTime != 0;
	}



	public bool IsSelected()
	{
		return mSelected;
	}



	public void Select()
	{
		mSelected = true;
	}



	public void Update()
	{
		if (mDamageTime != 0)
			mDamageTime--;
		if (mShootTime != 0)
			mShootTime--;
	}



	public bool Damage(int aDamage)
	{
		mHP -= aDamage;
		mDamageTime = 23;
		return mHP <= 0;
	}



	public bool CanShoot()
	{
		return mShootTime == 0 && !IsDamaged();
	}



	public void Shoot()
	{
		mShootTime = uniform(mFireRate, mFireRate * 2);
	}
}